## openjdk-7 7u71-2.5.3

=== debian/changelog ===
openjdk-7 (7u71-2.5.3-2~deb7u1) wheezy-security; urgency=low

  * Build for stable

 -- Moritz Muehlenhoff <jmm@debian.org>  Thu, 27 Nov 2014 00:02:13 +0100

openjdk-7 (7u71-2.5.3-2) unstable; urgency=medium

  * Regenerate the .orig.tar to omit a third hotspot tarball.
  * Really fix the libjpeg runtime dependency for sid and jessie.
    Closes: #766601.
  * Fix regression running JamVM after the 2.5.3 security update.
    Closes: #767771. LP: #1382205.
  * Fix regression running CACAO after the 2.5.3 security update.
  * Backport S8000897, VM crash in CompileBroker. Closes: #768747.
  * Fix building icedtea-sound on x32 (patch dropped in 7u71-2.5.3-1).
    Closes: #766610.
  * Don't use the compatibility path names from the ttf-dejavu packages
    for recent releases. LP: #1362099.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 13 Nov 2014 11:10:28 +0100

openjdk-7 (7u71-2.5.3-1) unstable; urgency=high

  * IcedTea7 2.5.3 release (based on OpenJDK 7u71).
  * Security fixes:
    - S8015256: Better class accessibility.
    - S8022783, CVE-2014-6504: Optimize C2 optimizations.
    - S8035162: Service printing service.
    - S8035781: Improve equality for annotations.
    - S8036805: Correct linker method lookup.
    - S8036810: Correct linker field lookup.
    - S8036936: Use local locales.
    - S8037066, CVE-2014-6457: Secure transport layer.
    - S8037846, CVE-2014-6558: Ensure streaming of input cipher streams.
    - S8038364: Use certificate exceptions correctly.
    - S8038899: Safer safepoints.
    - S8038903: More native monitor monitoring.
    - S8038908: Make Signature more robust.
    - S8038913: Bolster XML support.
    - S8039509, CVE-2014-6512: Wrap sockets more thoroughly.
    - S8039533, CVE-2014-6517: Higher resolution resolvers.
    - S8041540, CVE-2014-6511: Better use of pages in font processing.
    - S8041529: Better parameterization of parameter lists.
    - S8041545: Better validation of generated rasters.
    - S8041564, CVE-2014-6506: Improved management of logger resources.
    - S8041717, CVE-2014-6519: Issue with class file parser.
    - S8042609, CVE-2014-6513: Limit splashiness of splash images.
    - S8042797, CVE-2014-6502: Avoid strawberries in LogRecord.
    - S8044274, CVE-2014-6531: Proper property processing.

  [ Matthias Klose ]
  * Change B-D to libjpeg-dev to finish the transition to libjpeg-turbo
    (Ondřej Surý). Closes: #763489.
  * Depend on libnss3 instead of libnss3-1d for recent releases.
    Addresses: #760122.
  * Ship the apt binary and man page again. Closes: #765037.

  [ Bill Huey ]
  * Icedtea 2.5.3, jamvm-2.0.0 and icetea-sound-1.0.1 packaging updates.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 23 Oct 2014 15:53:05 +0200
