## openjdk-7 7u75-2.5.4

=== debian/changelog ===
openjdk-7 (7u75-2.5.4-2) unstable; urgency=medium

  * Fix build on mips64 and mips64el. Addresses #776295.
  * Fix the build using the updated patch not following symlinks.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 05 Feb 2015 18:22:28 +0100

openjdk-7 (7u75-2.5.4-1) unstable; urgency=high

  * IcedTea7 2.5.4 release (based on OpenJDK 7u75).
  * Security fixes
    - S8046656: Update protocol support.
    - S8047125, CVE-2015-0395: (ref) More phantom object references.
    - S8047130: Fewer escapes from escape analysis.
    - S8048035, CVE-2015-0400: Ensure proper proxy protocols.
    - S8049253: Better GC validation.
    - S8050807, CVE-2015-0383: Better performing performance data handling.
    - S8054367, CVE-2015-0412: More references for endpoints.
    - S8055304, CVE-2015-0407: More boxing for DirectoryComboBoxModel.
    - S8055309, CVE-2015-0408: RMI needs better transportation considerations.
    - S8055479: TLAB stability.
    - S8055489, CVE-2014-6585: Better substitution formats.
    - S8056264, CVE-2014-6587: Multicast support improvements.
    - S8056276, CVE-2014-6591: Fontmanager feature improvements.
    - S8057555, CVE-2014-6593: Less cryptic cipher suite management.
    - S8058982, CVE-2014-6601: Better verification of an exceptional invokespecial.
    - S8059485, CVE-2015-0410: Resolve parsing ambiguity.
    - S8061210, CVE-2014-3566: Issues in TLS.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 23 Jan 2015 12:14:42 +0100
